/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (C) 1998, Emmanuel CURIS

   Modle structural

   Messages d'erreur
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include "systeme.h"

#define CODE_MAXIMAL 3 /* Au-del, code d'erreur inconnu */

#include "atm_erreurs.txt"

int ATM_ERREUR(unsigned int numero, ...)
{
  char *c_1;
  int Z;
  int retour = 1;
  va_list params;

  if (numero > CODE_MAXIMAL)
    return SYS_ERREUR(ERREUR_INCONNUE, numero, "Mod"e_GRAVE"le structural");

  va_start(params, numero);

  switch (numero)
  {
  case ATOMES_CHEVAUCHANTS: /* 1 paramtre = chane */
    c_1 = va_arg(params, char *);
    (void) BI_ERR_alerte( NULL, &ERR_AtomesChevauchants, VRAI, c_1 );
    break;

  case ELEMENT_INCONNU: /* 1 paramtre = entier (int) */
    Z = va_arg(params, int);
    (void) BI_ERR_alerte( NULL, &ERR_ZInconnu, VRAI, Z );
    break;

  case TROP_LIAISONS:     /* Messages sans paramtre */
    (void) BI_ERR_alerte( NULL, &ERR_TropLiaisons, VRAI );
    break;

  case ATOMES_SUPERPOSES:
    (void) BI_ERR_alerte( NULL, &ERR_MemePosition, VRAI );
    break;

  default:
    (void) fprintf(stderr, "ATM_ERREUR : code d'erreur inconnu [%d]\n", numero);
  }

  va_end(params);

  return retour;
}
