/* LASE - Logiciel d'Analyse des Spectres Exprimentaux
   (C) 1996-2006, Emmanuel Curis

   Interface graphique : routines gnrales indpendantes du systme

   Gestion des vnements
   Dclarations (indpendantes de LASE)
*/

#ifndef BI_EVENEMENTS_COMMUN_H_
# define BI_EVENEMENTS_COMMUN_H_ /* Protection / inclusion multiple */

/* -------- Les codes de retour des fonctions qui grent des vnements ------------ */

#ifndef BI_EVENEMENT_NON_TRAITE	/* Pour pouvoir le redfinir sur certains environnements, si ncessaire ! */
/* vnements spciaux */
# define BI_EVENEMENT_TRAITE       ( 0) /* Renvoy si l'vnement a t trait, RAS */
# define BI_EVENEMENT_FEN_FERMEE   (-1) /* Renvoy si le traitement a conduit  fermer une fentre */
# define BI_EVENEMENT_FERMER_ARBRE (-2) /* Renvoy si le traitement a conduit  demander de fermer un arbre */
# define BI_EVENEMENT_FIN_PRG      (-3) /* Renvoy si le traitement a conduit  demander de quitter le prog */
# define BI_EVENEMENT_NON_TRAITE   (-4) /* Renvoy si l'vnement n'a pas t trait, avant conversion ! */
# define BI_EVENEMENT_ERREUR       (-5) /* Renvoy si une erreur a empch de traiter l'vnement */

# define BI_EVENEMENT_CODE_OBJET   (10000) /* + numro objet ; renvoy quand on ferme un arbre pour indiquer l'objet qui a servi  fermer */

/* Masques pour les vnements non-traits [compatibles evnt_multi] */
# define BI_EVENEMENT_CLAVIER  0x001 /* vnement clavier, non-trait */
# define BI_EVENEMENT_CLIC     0x002 /* vnement souris (clic), non-trait */
# define BI_EVENEMENT_RECT_1   0x004 /* vnement souris (entre/sortie du 1er rectangle), non-trait */
# define BI_EVENEMENT_RECT_2   0x008 /* vnement souris (entre/sortie du 2e rectangle), non-trait */
# define BI_EVENEMENT_MESSAGE  0x010 /* vnement message, non-trait */
# define BI_EVENEMENT_TIMER    0x020 /* vnement timer : le temps imparti est coul ! */
# define BI_EVENEMENT_RECT_3   0x040 /* vnement souris (entre/sortie du 3e rectangle), non-trait */
# define BI_EVENEMENT_SYSTEME  0x080 /* vnement message [systme ?], non-trait */
#endif

/* -------- Les fonctions qui grent les vnements (certains ou plusieurs) -------- */

int BI_AttendClic(struct fenetre *fenetre, int mode,
		  void (*pointeur)(struct fenetre *fenetre, int x, int y, int vx, int vy),
		  int *x, int *y, int *etat);

int BI_AttendEvenement(int masque,
		       int rect, int x_rc, int y_rc, int larg_rc, int haut_rc,
		       unsigned long compteur,
		       int *x, int *y, int *bouton, int *etat, unsigned int *touche, int *n_clic);

int BI_AttendRelache(struct fenetre *fenetre, int mode, int bouton,
		     void (*pointeur)(struct fenetre *fenetre, int x, int y, int vx, int vy),
		     int *x, int *y, int *etat);

#endif /* BI_EVENEMENTS_COMMUN_H_ */
