/* Essai de la bib. X
   (C) 1999, Emmanuel CURIS

   Programme 3 : initialisation, chargement du RSC, fentres mixtes.
   Un appui sur une touche quitte le programme
   Il y a un rticule sur la fentre
*/

#include <stdio.h>
#include <stdlib.h>

#include "bib_interface.h"
#include "../exafs.h"

unsigned long compte = 0;

static void rds_classique(Fenetre *fenetre, int x, int y, unsigned int larg, unsigned int haut)
{
  int points[4];

  compte++;

  vswr_mode(_PRG_station->handle, MD_REMPLACE);
  vsf_color(_PRG_station->handle, BLANC);

  points[0] = x;
  points[1] = y;
  points[2] = x + larg - 1;
  points[3] = y + haut - 1;
  v_bar(_PRG_station->handle, points);

  vsl_color(_PRG_station->handle, ROUGE);
  points[0] = fenetre->w_x;
  points[1] = fenetre->w_y + (fenetre->w_haut >> 1);
  points[2] = fenetre->w_x + (fenetre->w_larg >> 1);
  points[3] = fenetre->w_y;
  v_pline(_PRG_station->handle, 2, points);

  vsl_color(_PRG_station->handle, VIOLET);
  points[0] = points[2];
  points[1] = points[3];
  points[2] = fenetre->w_x + fenetre->w_larg;
  points[3] = fenetre->w_y + (fenetre->w_haut >> 1);
  v_pline(_PRG_station->handle, 2, points);

  vsl_color(_PRG_station->handle, NOIR);
  points[0] = points[2];
  points[1] = points[3];
  points[2] = fenetre->w_x + (fenetre->w_larg >> 1);
  points[3] = fenetre->w_y + fenetre->w_haut;
  v_pline(_PRG_station->handle, 2, points);

  vsl_color(_PRG_station->handle, JAUNE);
  points[0] = points[2];
  points[1] = points[3];
  points[2] = fenetre->w_x;
  points[3] = fenetre->w_y + (fenetre->w_haut >> 1);
  v_pline(_PRG_station->handle, 2, points);
}

static int clavier(Fenetre *fenetre, unsigned int touche, int etat)
{
  ENTREE_FONCTION( __FUNCTION__, "fenetre=%p touche=%u etat=%d", (void *) fenetre, touche, etat );

  if ( NULL == fenetre ) {
    SORTIE_FONCTION( __FUNCTION__, "%d [fenetre=NULL]", BI_EVENEMENT_ERREUR );
    return BI_EVENEMENT_ERREUR;
  }

  if ( ' ' == touche ) {
    SORTIE_FONCTION( __FUNCTION__, "%d [espace]", BI_EVENEMENT_TRAITE );
    return BI_EVENEMENT_TRAITE;
  }
  if ( K_CTRL & etat ) {
    (void) printf("Touche Ctrl appuye\n");
    SORTIE_FONCTION( __FUNCTION__, "%d [avec Ctrl]", BI_EVENEMENT_TRAITE );
    return BI_EVENEMENT_TRAITE;
  }

  SORTIE_FONCTION( __FUNCTION__, "%d [touche quelconque]", BI_EVENEMENT_FIN_PRG );
  return BI_EVENEMENT_FIN_PRG;
}

int main(void)
{
  Fenetre *fenetre;
  boolean sortie = FAUX;

  if ( BI_Initialiser( "../exafs.rsc", 0, NULL, NULL ) == FAUX ) {
    return -1;
  }

  /* -------- Fentre mixte, arbre en haut, sans infos -------- */
  fenetre = FEN_CreerAvecArbre( NAME|MOVER|SIZER|FULLER, "Fentre mixte minimale, arbre en haut", NULL,
				ELIM_MUMATRICE, BI_FEN_ARBRE_HAUT, NULL,
				rds_classique, clavier, NULL /* Clic */, NULL /* Message */, NULL /* Rect */, NULL /*Temps*/);
  if ( NULL == fenetre ) {
    printf("Echec  la cration de la fentre\n");
    BI_Terminer();
    return -3;
  }
  FEN_Ouvrir( fenetre );

  do {
    sortie = BI_AttendEvenement( 0,
				 0, 0, 0, 0, 0,
				 0UL,
				 NULL, NULL, NULL, NULL, NULL, NULL );
  } while ( sortie != BI_EVENEMENT_FIN_PRG );

/*   ferme_fenetre(fenetre); */

  /* -------- Fentre mixte, arbre en haut, avec infos -------- */
  fenetre = FEN_CreerAvecArbre( NAME|MOVER|SIZER|FULLER|INFO, "Fentre mixte minimale, arbre en haut", "Avec informations",
				ELIM_MUMATRICE, BI_FEN_ARBRE_HAUT, NULL,
				rds_classique, clavier, NULL /* Clic */, NULL /* Message */, NULL /* Rect */, NULL /*Temps*/);
  if (NULL == fenetre) {
    printf("Echec  la cration de la fentre\n");
    BI_Terminer();
    return -3;
  }
  FEN_Ouvrir( fenetre );

  do {
    sortie = BI_AttendEvenement( 0,
				 0, 0, 0, 0, 0,
				 0UL,
				 NULL, NULL, NULL, NULL, NULL, NULL );
  } while ( sortie != BI_EVENEMENT_FIN_PRG );

/*   ferme_fenetre(fenetre); */

  BI_Terminer();
  return 0;
}
