/* Essai de la bib. X
   (C) 2002, Emmanuel CURIS

   Essai des fentres mixtes Open-GL/Utilisateur
*/

#include <stdio.h>
#include <stdlib.h>

#include "bib_interface.h"

static void redessin(Fenetre *fenetre, int x, int y, unsigned int larg, unsigned int haut)
{
  int points[4];

  if (fenetre == NULL) return;

  vswr_mode(_PRG_station->handle, MD_REMPLACE);
  vsf_color(_PRG_station->handle, BLANC);

  points[0] = x;
  points[1] = y;
  points[2] = x + larg - 1;
  points[3] = y + haut - 1;
  v_bar(_PRG_station->handle, points);

  vsl_color(_PRG_station->handle, ROUGE);
  points[0] = fenetre->w_x;
  points[1] = fenetre->w_y + (fenetre->w_haut >> 1);
  points[2] = fenetre->w_x + (fenetre->w_larg >> 1);
  points[3] = fenetre->w_y;
  v_pline(_PRG_station->handle, 2, points);

  vsl_color(_PRG_station->handle, VIOLET);
  points[0] = points[2];
  points[1] = points[3];
  points[2] = fenetre->w_x + fenetre->w_larg;
  points[3] = fenetre->w_y + (fenetre->w_haut >> 1);
  v_pline(_PRG_station->handle, 2, points);

  vsl_color(_PRG_station->handle, NOIR);
  points[0] = points[2];
  points[1] = points[3];
  points[2] = fenetre->w_x + (fenetre->w_larg >> 1);
  points[3] = fenetre->w_y + fenetre->w_haut;
  v_pline(_PRG_station->handle, 2, points);

  vsl_color(_PRG_station->handle, JAUNE);
  points[0] = points[2];
  points[1] = points[3];
  points[2] = fenetre->w_x;
  points[3] = fenetre->w_y + (fenetre->w_haut >> 1);
  v_pline(_PRG_station->handle, 2, points);
}

static boolean clavier(Fenetre *fenetre, unsigned int touche, int etat)
{
  if ( NULL == fenetre ) return VRAI;

  if ( ' ' == touche ) return VRAI;
  if ( K_CTRL & etat ) {
    (void) printf("Touche Ctrl appuye\n");
    return VRAI;
  }

  return BI_EVENEMENT_FIN_PRG;
}

int main(void)
{
  Fenetre *fenetre;
  boolean sortie = FAUX;

  if ( BI_Initialiser( NULL, 0, NULL, NULL ) == FAUX ) {
    return -1;
  }

  fenetre = FEN_creer_mixte_gl(NAME|MOVER|FULLER|SIZER, "Fentre d'essai", DROITE,
			       redessin,
			       ( void (*)(Fenetre *, int, int, unsigned int, unsigned int) ) NULL,
			       ( void (*)(Fenetre *, int, int, int) ) NULL, 
			       clavier,
			       ( boolean (*)(Fenetre *, int, int, int , int, int) ) NULL,
			       ( boolean (*)(Fenetre *, Message *) ) NULL,
			       ( void (*)(Fenetre *, int, int, int, int) ) NULL,
			       ( boolean (*)(Fenetre *) ) NULL );

  do {
    sortie = BI_AttendEvenement( 0,
				 0, 0, 0, 0, 0, 0UL,
				 NULL, NULL, NULL, NULL, NULL, NULL);
  } while ( sortie != BI_EVENEMENT_FIN_PRG );

  BI_Terminer();
  return 0;
}
