/* Essai de la bib. X
   (C) 2007, Emmanuel CURIS

   Essai de fenêtre avec onglets
   2 onglets, arbres lus dans le RSC de LASE
*/

#include <stdio.h>
#include <stdlib.h>

#include "bib_interface.h"
#include "../exafs.h"

#define NOM_RESSOURCE "../exafs.rsc"

#define NOMBRE_ONGLETS 4

static BI_Onglet onglets[ NOMBRE_ONGLETS ] = {
  { "Graphes", 0, CHOIX_GRAPHE, (int (*)(void) ) NULL },
  { "Images", 0, CHOIX_IMAGE, (int (*)(void) ) NULL },
  { "Mod"e_GRAVE"les", 0, LISTE_MODELES, (int (*)(void) ) NULL },
  { "Mol"e_AIGU"cules", 0, LISTE_MOLECULES, (int (*)(void) ) NULL },
};

int main(void)
{
  Fenetre *fenetre;
  boolean sortie = FAUX;

  /* Lancement de l'interface */
  if ( BI_Initialiser( NOM_RESSOURCE, 0, NULL, NULL ) == FAUX ) {
    return -1;
  }

  /* Création de la fenêtre d'onglets */
  fenetre = FEN_CreerOnglets( NAME|MOVER, NOMBRE_ONGLETS, onglets );
  if ( NULL == fenetre ) {
    (void) fprintf(stderr, "%s, %s l.%u : Erreur en voulant créer les onglets\n",
		   __FILE__, __FUNCTION__, __LINE__);
  }

  /* On ouvre cette fenêtre */
  FEN_Ouvrir( fenetre );

  do {
    sortie = BI_AttendEvenement( 0,
				 0, 0, 0, 0, 0,
				 0UL,
				 NULL, NULL, NULL, NULL, NULL, NULL );
  } while ( sortie != BI_EVENEMENT_FIN_PRG );

  BI_Terminer();
  return 0;
}
