/* Bibliothque X-Window pour les interfaces
	    Tout ce qui se rapporte aux fentres
	    Fichier  inclure
	    Compatible avec gem_gene.c (version GEM : rfrence)
   (C) 1998, Emmanuel CURIS

 26 mars 1998
   * Cration du fichier
*/

#ifndef X_FENETRES_H_

#define X_FENETRES_H_ 

#include "X_arbres.h" /* Pour la structure Arbre */
#include "X_vdi.h"    /* Pour le type Palette */

typedef union
{
  int type;
  int tampon[8]; /* Message GEM classique */

  struct {
    int code;
    int application;
    int en_plus;
    int handle;
    int x, y, larg, haut;
  } fenetre; /* Message de fentre type GEM */

  struct {
    int code;
    int drapeau;
    void *pointeur;
  } divers; /* ad-hoc pour les messages de modification de graphe */
} Message; /* Pour le passage de messages */

struct fenetre;

typedef struct
{
  short int mode;         /* Position de la sous-fentre Open-GL */
/*   Window handle; */          /* De la sous-fentre contenant l'image Open-GL */
  Pixmap fond;            /* Qui contient le rsultat - pour acclrer l'affichage */
#ifdef AVEC_OPEN_GL_
  GLXContext gl_contexte; /* Pour le dessin avec Open GL  */
  GLXPixmap image;        /* Idem, mais aves les infos Open-GL */
#endif
  boolean refaire;        /* VRAI s'il faut refaire l'image */
  /* ---- Fonctions  appeler en cas d'vnement (NULL = identiques  celles de la fentre mre) ----
     Remarque : ne contient que ce qui n'existe pas pour une fentre classique
                puisque de toute faon un dessin OpenGL est forcment dans une (sous-)fentre GL_FENETRE !
  */
/*   void    (*rds_gl)  (struct fenetre *, int x, int y, unsigned int larg, unsigned int haut); /\* Redessin : partie GL *\/ */
  void    (*rds_post)(struct fenetre *, int x, int y, unsigned int larg, unsigned int haut); /* Redessin : X aprs */
  int     (*deplace) (struct fenetre *, int bouton, int etat, int x, int y); /* Clic */
  int     (*temps)   (struct fenetre *);                                     /* Timer */
  int vx_x, vx_y; /* Anciennes coordonnes, pour un ventuel rticule */
} BI_infos_GL;

/* Structure utilise pour les infos sur les onglets */

struct fen_onglets {
  unsigned int onglet_actif;
  Window *onglets;
};

typedef struct fenetre   /* La structure fentre */
{
  struct fenetre *suivante;  /* Chanage des structures de fentre  */
  int    attributs;          /* Attributs de cette fentre          */
  int    type;               /* codes dans fenetres.h, BI_FENETRE_* */
  int    position;           /* Position de la fentre dans la fentre mre, cf. fenetres.h, BI_FEN_ARBRE_* */

  char *titre;         /* Ligne de titre */
  char *infos;         /* Ligne d'informations - pas const car strdup pour la crer */

  int x,y;
  unsigned int larg,haut;    /* Coordonnes externes de la fentre                 */
  int w_x,w_y;
  unsigned int w_larg,w_haut;/* Coordonnes internes de la fentre                 */

  int vx_x, vx_y; /* Ancienne position de la souris [pour le pointeur] */

  /* Les routines de gestion */
  void (*redessin) (struct fenetre *, int x, int y, unsigned int larg, unsigned int haut);    /* Redessin   */
  void (*ascenseur)(struct fenetre *, int type, int ss_type, int position); /* Ascenseurs */
  int  (*clavier)  (struct fenetre *, unsigned int touche, int etat);       /* Clavier    */
  int  (*clic)     (struct fenetre *, int bouton, int n_clic, int etat, int x, int y); /* Clic */
  int  (*message)  (struct fenetre *, Message *message);
  void (*rect)     (struct fenetre *, int x, int y, int vx_x, int vx_y);    /* Pointeur  */
  int  (*temps)    (struct fenetre *);                                      /* Timer     */

  struct                     /* Une srie de drapeaux divers                       */
  {
    unsigned repliee : 1; /* VRAI si elle est replie   */
    unsigned icone   : 1; /* VRAI si elle est iconifie */
    unsigned redessin: 1; /* VRAI si il faut tout redessiner en cas de changement de taille */
    unsigned ouverte : 1; /* VRAI si elle est ouverte   */
    unsigned palette : 1; /* VRAI si elle a sa propre palette */
    unsigned util_2  : 1; /* Utilisateur, 2 */
    unsigned util_1  : 1; /* Utilisateur, 1 */
    unsigned rds_dem : 1; /* VRAI : on a dj demand un redessin, pas encore trait */
    unsigned util_3  : 1; /* Utilisateur, 3 [LASE : il existe un graphe associ  la fentre] */
  } drapeaux;
  struct {
    unsigned taille      : 1; /* VRAI -> appeler message si chgmt de taille */
    unsigned position    : 1; /* et ainsi de suite...                 */
    unsigned plein_ecran : 1;
    unsigned premier_plan: 1;
    unsigned arriere_plan: 1;
    unsigned fermeture   : 1;
    unsigned autres      : 1;
    unsigned utilisateur : 1;
  } msg_masque; /* Spcifie les messages qui doivent tre transmis  la fentre */

  unsigned int numero_arbre; /* Numro de l'arbre d'objet */
  Arbre *arbre;		     /* Adresse de l'arbre associ  la fentre */

  /* Les sous-fentres. Toujours prsent, car utilis pour les arbres en fentre mixte ! */
  unsigned long nbr_ss_fenetres;
  struct fenetre **ss_fenetres;

  void *info_1;	/* Adresses pour associer quelque chose  la fentre : utilisateur */
  void *info_2;	/*  mettre & rcuprer avec FEN_StockerInformations() et */

  /* ---------- Spcifique  X-Windows ------------ */

  BI_infos_GL *open_gl;		/* Infos Open GL pour affichage X */

  Window handle; /* Le handle de la fentre associe  cette structure */

#ifdef XGEM_AVEC_CLOSER_
  Window closer; /* Normalement, le gestionnaire de fentres s'en charge, mais au cas o... */
#endif
  Window barre_d_infos;
  Window fleche_haute;
  Window fleche_basse;
  Window fond_asc_vertical;
  Window bouton_asc_vertical;
  Window fleche_gauche;
  Window fond_asc_horizontal;
  Window bouton_asc_horizontal;
  Window fleche_droite;

  XSizeHints *taille; /* Paramtres de taille : pour le WM */

  /* Le contexte d'entre au clavier */
  XIC  xic;            /* Le contexte proprement dit */
  long evenements_xic; /* Les vnements X que doit pouvoir recevoir l'IC ci-dessus */
} Fenetre;

/* Les attributs possibles (en plus de ceux de base) */
/* Remarque : ne sont pas utiles sous X FULLER, MOVER, SIZER, HOTCLOSE, SMALLER */

#define TOUS_SF_ASC    (NAME|CLOSER|FULLER|MOVER|INFO|SIZER|HOTCLOSE|SMALLER) /* Tout sauf les ascenseurs */
#define ASC_VERTICAL   (UPARROW|DNARROW|VSLIDE) /* Tout pour l'ascenseur vertical   */
#define ASC_HORIZONTAL (LFARROW|RTARROW|HSLIDE) /* --------------------- horizontal */
#define TOUS_BOUTONS   0xFFFF                   /* Tous les gadgets de fentre prsents */

/* -------- Routines spcifiques de la version X-Windows -------- */

#ifdef _LIBRAIRIE_X_
# ifdef AVEC_OPEN_GL_
boolean FEN_GL_choisit_contexte(Fenetre *fenetre, boolean mode);
# endif /* AVEC_OPEN_GL */

#define FEN_Afficher(f) XMapWindow( BI_Display, f->handle );
#define FEN_Cacher(f)   XUnmapWindow( BI_Display, f->handle );

int FEN_ote_evenement(Window fenetre);

int change_taille_fenetre(Fenetre *fenetre, int nv_larg, int nv_haut);

Fenetre *BIX_QuelleFenetre(Window fenetre); /* Conversion fentre X ==> fentre de la bib. */
int      quel_handle   (Fenetre *fenetre); /* Conversion FEN * / handle GEM - dans X_wind_lib.c */

void OBJ_creer_fenetres(Arbre *arbre, Window mere, int objet, int obj_pere);

int BIX_QuelOnglet(Fenetre *fenetre, Window fen_X, boolean *est_actif);

#endif /* _LIBRAIRIE_X_ */

#endif /* X_FENETRES_H_ */
