/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque de base VDI (fonctions vq_??? : lecture de paramtres) */

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <stdlib.h>

#include "Bib_X.h"

#ifdef AVEC_VDI_VQ_COMPLET_
void vq_mouse          (int handle, int  *status, int  *px, int  *py);
void vq_key_s          (int handle, int  *status);

/****** Inquire library ******************************************************/

void vq_color          (int handle, int index, int set_flag, int  *rgb);
void vq_cellarray      (int handle, int  *pxyarray, int row_length, int num_rows,
			int  *el_used, int  *rows_used, int  *status, int  *colarray);
void vql_attributes    (int handle, int  *attrib);
void vqm_attributes    (int handle, int  *attrib);
void vqf_attributes    (int handle, int  *attrib);
#endif

void vqt_attributes(int handle, int  *attributs)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return;

  attributs[0] = 0;                    /* Fonte utilise    */
  attributs[1] = station->txt_couleur; /* Couleur du texte  */
  attributs[2] = station->txt_angle;   /* Angle de rotation */
  attributs[3] = station->txt_just;
  attributs[4] = station->txt_vert;
  attributs[5] = 0; /* ? attributs graphiques ? */

  attributs[6] = BI_Fonte->max_bounds.width;
  attributs[7] = BI_Fonte->max_bounds.ascent/*  + _Fonte->ascent */;
  attributs[8] = attributs[6]; /* Cellule = caractre pour simplifier */
  attributs[9] = attributs[7];
}

#ifdef AVEC_VDI_VQ_COMPLET_
void vq_extnd          (int handle, int owflag, int *work_out);
void vqin_mode         (int handle, int dev_type, int *input_mode);
void vqt_extent        (int handle, char *string, int *extent);
int  vqt_width         (int handle, char character, int *cell_width,
                          int *left_delta, int *right_delta);
#endif

/* Donne le nom de la fonte indique
   Attention, nom_fonte est un TABLEAU dans lequel on copie le nom.
   Il doit faire au moins 32 caractres de long
*/

int vqt_name(int handle, int element_num, char *nom_fonte)
{
  Station_VDI *station;

#ifdef _DEVELOPPE_
  printf("vqt_name( handle = %d, element_num = %d, nom_fonte = %p\n", handle, element_num, (void *) nom_fonte );
#endif

  station = quelle_station(handle);
  if (station == NULL) {
    nom_fonte = "vqt_name : erreur survenue";
    return -1;
  }

  strncpy(nom_fonte, "Nom inconnu", 32);
  return 0;
}

#ifdef AVEC_VDI_VQ_COMPLET_
void vqt_fontinfo      (int handle, int  *minADE, int *maxADE,
                          int *distances, int *maxwidth,
                          int *effects);
int  vqt_justified     (int handle, int x, int y, char *string,
                          int length, int word_space, int char_space,
                          int *offsets);
void vq_chcells        (int handle, int *rows, int *columns);
void vq_curaddress     (int handle, int *row, int *column);
int  vq_tabstatus      (int handle);
void vq_scan           (int handle, int *g_height, int *g_slices,
                          int *a_height, int *a_slices, int *factor);
void vq_tdimensions    (int handle, int *xdimension, int *ydimension);
int  vqp_filmname      (int handle, int index, char *name);
void vqp_films         (int handle, char *film_names);
void vqp_state         (int handle, int *port, char *film_name,
                          int *lightness, int *interlace,
                          int *planes, int *indexes);
int vqp_error         (int handle);
#endif

void vqt_devinfo(int handle, int pilote, int *existe, char *nom)
{
#ifdef _DEVELOPPE_
  printf("vqt_devinfo( handle = %d, pilote = %d, existe = %p, nom = %p\n",
	 handle, pilote, (void *) existe, (void *) nom);
#endif

  *existe = FAUX; /* De toute faon, aucun pilote GDOS gr pour l'instant */
}

int vq_gdos(void)
{
  return -2; /* GDOS n'est pas mul ici */
}
