/* Bibliothque X-Window pour les interfaces
   (C) 1998-2001, Emmanuel CURIS
   Cration le 25 novembre 2001,  partir de FSEL.H

   Description du slecteur de fichiers
*/

#ifndef FSEL_INCLUSION_

#define FSEL_INCLUSION_ /* Protection contre l'inclusion multiple */

/* ------ Indice des objets dans le slecteur ------ */

#define FSEL_AVANT       3   /* Bouton : faire dfiler la liste vers le haut */
#define FSEL_APRES       4   /* Bouton : faire dfiler la liste vers le bas  */
#define FSEL_ASC         5   /* Bote  : fond de l'ascenseur, de la liste  */
#define FSEL_PREM_NOM    6   /* Chane : premier nom affich dans la liste */
#define FSEL_DER_NOM    20   /* Chane : dernier nom affich dans la liste */
#define FSEL_OK         21   /* Bouton : confirmer le nom du fichier */
#define FSEL_ANNULER    22   /* Bouton : annuler l'appel du slecteur */
#define FSEL_FICHIER    24   /* Texte ditable : nom du fichier  */
#define FSEL_BOUTON     25   /* Bote  : ascenseur de la liste  */
#define FSEL_MASQUE     27   /* Bouton : choix du masque d'affichage des fichiers */
#define FSEL_CHEMIN     28   /* Texte ditable infini : chemin actuel */
#define FSEL_REMONTE    29   /* Bouton : remonter dans l'arborescence */

/* ------ Dfinition du slecteur -------- */

OBJECT adresse_selecteur[] = /* L'arbre proprement dit */
{ 
  {	 -1,        1, FSEL_REMONTE, G_BOX     ,   /* Objet 0 : bote servant de fond */
       NONE, OUTLINED, {(char *) 0x00021100L},
     0x0000, 0x0000, 0x003A, 0x0015 },

  {       2,       -1,       -1, G_STRING ,   /* Objet 1 : texte "Chemin :"  */
       NONE, NORMAL, {"Chemin : "},
       0x0001, 0x0001, 0x0009, 0x0001},

  {  FSEL_AVANT, FSEL_PREM_NOM, FSEL_DER_NOM, G_BOX,  /* Objet 2  */
       NONE, NORMAL, {(char *) 0x00FF1100L},
       0x0001, 0x0003, 0x0025, 0x000F},

  {  FSEL_APRES,       -1,       -1, G_BUTTON  ,   /* Objet 3 FSEL_AVANT */
       SELECTABLE, NORMAL, {"\001"},
       0x0026, 0x0004, 0x0002, 0x0001},

  {  FSEL_ASC,       -1,       -1, G_BUTTON  ,   /* Objet 4 FSEL_APRES */
       SELECTABLE, NORMAL, {"\002"},
       0x0026, 0x0011, 0x0002, 0x0001},

  {  FSEL_OK , FSEL_BOUTON, FSEL_BOUTON, G_BOX     ,   /* Objet 5 FSEL_ASC */
       NONE, NORMAL, {(char *) 0x00FF1141L},
       0x0026, 0x0005, 0x0002, 0x000C},

  {   7,       -1,       -1, G_STRING  ,   /* Objet 6 FSEL_PREM_NOM */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0000, 0x0025, 0x0001},

  {   8,       -1,       -1, G_STRING  ,   /* Objet 7  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0001, 0x0025, 0x0001} ,

  {   9,       -1,       -1, G_STRING  ,   /* Objet 8  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0002, 0x0025, 0x0001},

  {  10,       -1,       -1, G_STRING  ,   /* Objet 9  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0003, 0x0025, 0x0001},

  {  11,       -1,       -1, G_STRING  ,   /* Objet 10  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0004, 0x0025, 0x0001},

  {  12,       -1,       -1, G_STRING  ,   /* Objet 11  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0005, 0x0025, 0x0001},

  {  13,       -1,       -1, G_STRING  ,   /* Objet 12  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0006, 0x0025, 0x0001},

  {  14,       -1,       -1, G_STRING  ,   /* Objet 13  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0007, 0x0025, 0x0001},

  {  15,       -1,       -1, G_STRING  ,   /* Objet 14  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0008, 0x0025, 0x0001},

  {  16,       -1,       -1, G_STRING  ,   /* Objet 15  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x0009, 0x0025, 0x0001},

  {  17,       -1,       -1, G_STRING  ,   /* Objet 16  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x000A, 0x0025, 0x0001},

  {  18,       -1,       -1, G_STRING  ,   /* Objet 17  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x000B, 0x0025, 0x0001},

  {  19,       -1,       -1, G_STRING  ,   /* Objet 18  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x000C, 0x0025, 0x0001},

  {  FSEL_DER_NOM,       -1,       -1, G_STRING  ,   /* Object 19  */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x000D, 0x0025, 0x0001},

  {  2,       -1,       -1, G_STRING  ,   /* Objet 20 FSEL_DER_NOM */
       SELECTABLE, NORMAL,
     {"Nom de fichier     2         3         4         5"},
       0x0000, 0x000E, 0x0025, 0x0001},

  {  FSEL_ANNULER,       -1,       -1, G_BUTTON  ,   /* Object 21 FSEL_OK */
       SELECTABLE|DEFAULT|EXIT, NORMAL, {"Ok"},
       0x002A, 0x0004, 0x000E, 0x0001},

  {  23,       -1,       -1, G_BUTTON  ,   /* Objet 22 FSEL_ANNULER */
       SELECTABLE|EXIT, NORMAL, {"Annuler"},
       0x002A, 0x0006, 0x000E, 0x0001},

  {  FSEL_FICHIER,       -1,       -1, G_STRING  ,   /* Object 23  */
       NONE, NORMAL, {"Nom : "},
       0x0001, 0x0013, 0x0006, 0x0001},

  {  26,       -1,       -1, G_TXT_INFINI   ,   /* Objet 24 FSEL_FICHIER */
       EDITABLE, NORMAL, { NULL },
       0x0007, 0x0013, 50, 1},

  {  FSEL_ASC,       -1,       -1, G_BOX     ,   /* Object 25 FSEL_BOUTON */
       NONE, NORMAL, {(char *) 0x00FF1100L},
       0x0000, 0x0000, 0x0002, 0x0002},

  {  FSEL_MASQUE,       -1,       -1, G_STRING  ,   /* Object 26 */
       NONE, NORMAL, {"Extensions :"},
       0x002A, 0x0009, 0x000C, 0x0001},

  {  FSEL_CHEMIN,       -1,       -1, G_BUTTON  ,   /* Object 27 FSEL_MASQUE */
       SELECTABLE, SHADOWED, {"*.*"},
       0x002A, 0x000B, 0x000E, 0x0001},

  {  FSEL_REMONTE,       -1,       -1, G_TXT_INFINI,  /* Objet 28 (FSEL_CHEMIN) : chemin courant */
       EDITABLE, NORMAL, { NULL },
       0x000A, 0x0001, 0x002E, 0x0001},

  {  0,       -1,       -1, G_BUTTON  ,   /* Objet 29 FSEL_REMONTE */
       SELECTABLE|LASTOB, NORMAL, {"\005"},
       0x0026, 0x0003, 0x0002, 0x0001}
};

#endif /* FSEL_INCLUSION_ */
