%{
  /* Analyse d'une chane de texte pour en dduire une formule mathmatique
     = relation entre graphes, transformations de coordonnes,...

     (C) 2001 Emmanuel Curis, fichier lex  l'origine
  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "systeme.h"

#include "c_formel.h"
#include "Formel/formules.h"
#include "science.h"

int formuleslex(void); /* Prototype pour viter un warning avec gcc -W -Wall */

#define YY_NEVER_INTERACTIVE 1 /* vite un warning avec gcc -W -Wall, sur isatty() */
#define YY_NO_UNPUT          1 /* Idem, sur yyunput non utilise quoique dfinie   */
%}


/* Variables reconnues, en majuscule forcment : X, Y, Z, T, I, R, sX, sY
   Rq : les nombres sont supposs toujours positifs, car le - de signe est gr dans yacc
*/

Nombre (([0-9]+)|([0-9]*\.[0-9]+)([eE][-+]?[0-9]+)?)
Variable ([XYZTIRxyztir])|([sS][xXyY])
Fonction [A-Za-z]+([0-9]+)?

%option nointeractive
%option noyywrap
%pointer

%%

Pi { formuleslval.nombre = M_PI; return NOMBRE; }

{Nombre}   { formuleslval.nombre = atof(formulestext);
           /*  printf("Nombre lu : %g\n", formuleslval.nombre); */
	     return NOMBRE;
           }

{Variable} { if ( ( 's' == formulestext[0] ) || ( 'S' == formulestext[0] ) ) {
               if ( ( 'x' == formulestext[ 1 ] ) || ( 'X' == formulestext[ 1 ] ) )
                 formuleslval.code_variable = 's';
	       else if ( ( 'y' == formulestext[ 1 ] ) || ( 'Y' == formulestext[ 1 ] ) )
                 formuleslval.code_variable = 'S';
	       else
                 formuleslval.code_variable = 'e';
             } else {
               formuleslval.code_variable = formulestext[0];
	     }
        /* Comme lex essaye de lire le plus long, normalement 1 lettre devrait coller comme variable */
        /*     printf("C'est une variable : %c\n", formuleslval.code_variable); */
	     return VARIABLE;
           }

{Fonction} { formuleslval.nom_fonction = strdup(formulestext);
/*              printf("Fonction repre : %s\n", formulestext); */
	     return FONCTION;
           }

[ \t] ;
\n return 0;

. return formulestext[0];

%%
