/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (C) 1999-2003, Emmanuel CURIS

   Informations sur un graphe
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "systeme.h"

#include "images.h"

#include "img_infos.txt"

/* ~~~~~~~~ Variables locales ~~~~~~~~ */

/* ~~~~~~~~ Ralisation pratique ~~~~~ */

/* -------- Quel est le genre de l'image ? -------- */

const char *IMG_TXT_Genre(int genre)
{
  if ( ( genre < 0 ) || ( genre >= NOMBRE_GENRE_IMAGES ) ) {
    (void) fprintf(stderr, "%s,%s l.%u : Genre de d'image inconnu [%d]\n",
		   __FILE__, __FUNCTION__, __LINE__, genre);
    FIN_ANTICIPEE( FIN_ERREUR_GRAVE );
    return "Genre inconnu";
  }

  return textes_genres_image[ genre ];
}

/* -------- Quel est le type de l'image ? -------- */

const char *IMG_TXT_Type(int type)
{
  if ( type < 0 ) {
    if ( IMG_AUTRE_TYPE == type ) return "Autre";
    if ( IMG_SANS_TYPE  == type ) return "<Sans type>";

    (void) fprintf(stderr, "%s,%s l.%u : Type d'image incorrect [%d]\n",
		   __FILE__, __FUNCTION__, __LINE__, type);
    FIN_ANTICIPEE( FIN_ERREUR_GRAVE );
    return "<Type inconnu>";
  }
  if ( type >= IMG_NOMBRE_TYPES ) {
    (void) fprintf(stderr, "%s,%s l.%u : Type d'image incorrect [%d]\n",
		   __FILE__, __FUNCTION__, __LINE__, type);
    FIN_ANTICIPEE( FIN_ERREUR_GRAVE );
    return "<Type inconnu>";
  }

  return textes_types_image[ type ];
}
