/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (C) 1999, Emmanuel CURIS
   Cration : le 10 juin 1999

   Paramtres associs aux diffrents cristaux de monochromateurs
*/

#ifndef CRISTAUX_H_

#define CRISTAUX_H_ /* protection contre l'inclusion multiple */

#define SILICIUM_111  0
#define SILICIUM_220  1
#define SILICIUM_311  2
#define SILICIUM_331  3
#define SILICIUM_422  4
#define GERMANIUM_111 5
#define GERMANIUM_220 6
#define GERMANIUM_400 7
#define GERMANIUM_422 8
#define QUARTZ_1010   9
#define QUARTZ_1011  10
#define QUARTZ_1012  11
#define QUARTZ_1122  12
#define QUARTZ_2023  13
#define QUARTZ_2131  14
#define QUARTZ_5052  15
#define LIF_200      16
#define LIF_220      17
#define LIF_420      18
#define LIF_422      19
#define TOPAZE_002   20
#define TOPAZE_006   21
#define TOPAZE_200   22
#define TOPAZE_303   23
#define MICA_002     24
#define MICA_010     25
#define MICA_100     26
#define MICA_201     27
#define MICA_331     28
#define FLUORITE_111 29
#define FLUORITE_220 30
#define FLUORITE_222  31
#define ALUMINIUM_111 32
#define ALUMINIUM_200 33
#define GYPSE_002     34
#define GYPSE_020     35
#define NACL_200      36
#define CALCITE_200   37
#define CALCITE_211   38
#define ADP_101       39
#define ADP_112       40
#define ADP_200       41
#define GRAPHITE_002  42
#define PET_002       43
#define EDDT_020      44
#define SHA_110       45
#define CUIVRE_111    46
#define INSB_111      47
#define TAP_001       48

#define NOMBRE_CRISTAUX 49

extern const char *noms_cristaux[]; /* Dans variables.c */

typedef struct
{
  float d_hkl; /* Distance interrticulaire - en A */
  float V;     /* Volume de la maille  - en A^3 */
  float F_hkl; /* Facteur de structure */
} Cristal_Mono;

extern const Cristal_Mono cristaux[]; /* Dans variables.c */

#endif /* CRISTAUX_H_ */
