/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (C) 1998-2003, Emmanuel CURIS

   Gnralits du programme LASE (interface graphique)

   Gestion et prparation du menu de gestion des banques de donnes de spectres
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "systeme.h"

#include "exafs.h"

#include "fichiers.h"
#include "graphes.h"
#include "interface.h"

/* ~~~~~~~~ Variables locales ~~~~~~~~ */

/* ~~~~~~~~ Fonctions locales ~~~~~~~~ */

static int CLV_men_banque(unsigned int touche, int etat, int *renvoi);
int MEN_PreparerBanque( void );

/* -------- Prparation du menu -------- */

int MEN_PreparerBanque( void )
{
  arbres[MEN_BANQUE].clavier = CLV_men_banque;

  return 0;
}

/* -------- Gestion des options -------- */

int MEN_banque(unsigned int option)
{
  Graphe *retour;

  switch (option)
  {
  case MBD_INFOS:
    ARB_AppelerInformations();
    return VRAI;

  case MBD_V_EXTRAIT:
    GER_infos(TRAITE_SPECTRES, 0, 0);
    return VRAI;

  case MBD_V_AJUSTE:
    GER_infos(EXF_AJUSTEMENTS, 0, 0);
    return VRAI;

  case MBD_V_THEORIE:
    GER_infos(CALC_THEORIQUES, 0, 0);
    return VRAI;

  case MBD_V_STRUCT:
    GER_infos(STRUCTURE, 0, 0);
    return VRAI;

  case MBD_V_FLUOX:
    GER_infos(INFOS_FLUOX, 0, 0);
    return VRAI;

  case MBD_CHARGER: /* Marche pour tout, normalement */
    retour = charger(NULL);
    if (retour != NULL) GRF_aller(retour);
    return VRAI;
  }

  return VRAI;
}

/* -------- Raccourcis clavier -------- */

static int CLV_men_banque(unsigned int touche, int etat, int *renvoi)
{
  *renvoi = 0; /* On ne quitte pas un menu de toute faon... */

  if (etat & K_CTRL) /* On appuyait sur Control */
  {
    if ( touche <= 255 )
      touche = (unsigned int) toupper( (int) touche); /* Comportement indfini pour autres codes ! */
    switch ( touche )
    {
    case 'A':   /* ^A = appeler le menu d'Ajustements            */
      GER_infos(EXF_AJUSTEMENTS, 0, 0);
      return VRAI;

    case 'C':   /* ^C = Charger - marche aussi pour les structures 3D, maintenant... */
      return MEN_extrait(CHARGER);

    case 'E':   /* ^E = appeler le menu d'Extraction d'un graphe */
      GER_infos(TRAITE_SPECTRES, 0, 0);
      return VRAI;

    case 'L':   /* ^L = appeler la liste des graphes */
      FEN_premierplan( fenetre_onglets );
      BI_Onglets_ChangerActif( fenetre_onglets, BI_ONGLET_GRAPHES );
      return VRAI;

    case 'Q':		/* ^Q = Quitter */
      return MEN_extrait(QUITTER);

    case 'T':   /* ^T = appeler le menu de calculs thoriques    */
      GER_infos(CALC_THEORIQUES, 0, 0);
      return VRAI;

#ifdef _DEVELOPPE_
    default:
      printf("On appuyait sur la lettre no : %d (%c)\n", touche, (char) touche);
      break;
#endif
    }
  }

  return FAUX; /* Par dfaut, message non-trait */
}
