/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (c) 1998, Emmanuel CURIS
   Cration : 3 juin 1998  

   Module de lissage et interpolation des spectres

   Traitement des erreurs
*/

#include <stdio.h>
#include <stdarg.h>

#include "systeme.h"

#include "lissage.h"

#define NOMBRE_MESSAGES 4

#include "ERR_lissage.txt"

int LIS_ERREUR(int num_erreur, ...)
{
  int reponse;
  char *ch_1;
  va_list params;

  va_start(params, num_erreur);

  switch ( num_erreur )
  {
  case ERR_LIS_DOUBLON: /* %s = nom du graphe posant le problme */
    ch_1 = va_arg(params, char *);
    reponse = BI_ERR_alerte(NULL, &ERR_LIS_Doublons , VRAI, ch_1);
    break;

  case ERR_LIS_TROP_PEU_POINTS:
    reponse = BI_ERR_alerte(NULL, &ERR_LIS_TropPeuPoints , VRAI);
    break;

  case ERR_LIS_DIV_ZERO:
    reponse = BI_ERR_alerte(NULL, &ERR_LIS_DivisionZero , VRAI);
    break;

  case ERR_LIS_MEMOIRE:
    reponse = BI_ERR_alerte(NULL, &ERR_LIS_ManqueMemoire , VRAI);
    break;

  case ERR_LIS_NON_TRIE: /* %s = nom du graphe */
    reponse = BI_ERR_alerte(NULL, &ERR_LIS_NonTrie , VRAI);
    break;

  case ERR_LIS_NON_INVERSIBLE:
    reponse = BI_ERR_alerte(NULL, &ERR_LIS_NonInversible , VRAI);
    break;

  default:
    reponse = SYS_ERREUR(ERREUR_INCONNUE, num_erreur, "Lissage, Interpolation");
    break;
  }

  va_end( params );

  return reponse;
}
