/* LASE - Traitement de l'E.X.A.F.S. sur Atari & X-Window
   Tout ce qui concerne l'ajustement par un modle  n couches

   (c) 1996, 1998 - Emmanuel CURIS ; cration du fichier : 27 mai 1998

   Messages d'erreur de ce module
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "systeme.h"

#define NOMBRE_MESSAGES 21

#ifdef _ENGLISH_

static const char *messages[NOMBRE_MESSAGES + 1] = 
{
  "[1][--- N layers model ---| "
     "| No layer defined!"
     "| Fitting is impossible][ Ok ]",

  "[1][--- N layers model ---| "
     "|No phase shift for layer"
     "|%.30s"
     "|This layer won't be used][Continue]",

  "[1][--- N layers model ---| "
     "|No amplitude for layer"
     "|%.30s"
     "|This layer won't be used][Continue]",

  "[1][--- N layers model ---| "
     "|No free variable defined"
     "|Fitting is not possible][ Ok ]",

  "[3][Wrong init. for a variable"
     "|Layer: %.23s"
     "|Initial %.8s: %.5g"
     "|min : %.5g - max : %.5g"
     "|Automatic correction.][Continue]",

  "[3][----- N layers model -----"
     "| Only the exafs or Fourier"
     "|transform graphs can be used"
     "|as a reference for fitting.][ Cancel ]",

  "[2][----- N layers model ----- |"
     "|    Do you really want to "
     "|stop fitting ?][ No | Yes ]",

  "[3][** Closing is impossible **"
     "| It's not possible to close"
     "|the fitting window while"
     "|fitting !][ Ok ]",

  "[3][----- N shells model -----"
     "|   The fitting domain that"
     "|you selected is empty!][ Cancel ]",

  "[3][------- N shells model -------"
     "|    The fitting domain you"
     "|selected is not defined in"
     "|the experimental spectrum!][ Cancel ]",

  "[2][------- Start fitting -------"
     "| What must we done of the "
     "|previous fit results ?][ Keep | Loose | Cancel ]",

  "[3][------- No error bars -------"
     "|There's no standard deviation"
     "|(mean or for each point)."
     "|Impossible to use error bars!][ Suite ]",

  "[3][Wrongly initialized variable"
     "|Shell: %.23s"
     "|The lower limit for DE0 could"
     "|give negative k values."
     "|Automatic correction.][Continue]",

  "[3][------ End of fitting ------"
     "|  One variable doesn't change"
     "|in a significativ way"
     "|Shell: %.23s"
     "|Variable: %.20s][ OK ]",

  "[3][------ End of fitting ------"
     "|  One variable reached the"
     "|allowed values limit."
     "|Shell: %.23s"
     "|Variable: %.20s][ OK ]",

  "[3][------ End of fitting ------"
     "|  The final error doesn't"
     "|change in a significant way"
     "|Error: %.10g][ OK ]",

  "[3][------ End of fitting ------"
     "|  The final error is lower"
     "|than the wanted error"
     "|Error: %.10g][ OK ]",

  "[3][------ End of fitting ------"
     "|  Algorithm has converged -"
     "|it's impossible to minimize"
     "|the obtained error."
     "|Error: %.10g][ OK ]",

  "[3][ ! Fitting became impossible !"
     "| One of the spectra necessary"
     "|for fitting has been deleted!"
     "|Fitting halted.][ Ok ]",

  "[3][--- Fitting is impossible ---"
     "|   The selected absorbing atom"
     "|has no experimental EXAFS.][Cancel]",

  "[3][-- Fitting results checking --"
     "|  One variable reached the"
     "|allowed values limit."
     "|Shell: %.23s"
     "|Variable: %.20s][ Continue | Remove | Cancel ]",

  /*   v----------------------------v */
  "[3][------ Fitting stopped ------"
     "|  An error occured while doing"
     "|the model computation.][ Abort ]"
};

#else /* Par dfaut, en franais */

static const char *messages[NOMBRE_MESSAGES + 1] = 
{
  "[1][--- Mod"e_GRAVE"le "a_GRAVE" n couches ---| "
     "| Aucune couche n'a "e_AIGU"t"e_AIGU" d"e_AIGU"finie !"
     "| L'ajustement est impossible.][Compris]",

  "[1][--- Mod"e_GRAVE"le "a_GRAVE" n couches ---| "
     "|Pas de phase pour la couche"
     "|%.30s"
     "|La couche ne sera pas utilis"e_AIGU"e][Suite]",

  "[1][--- Mod"e_GRAVE"le "a_GRAVE" n couches ---| "
     "|Pas d'amplitude pour la couche"
     "|%.30s"
     "|La couche ne sera pas utilis"e_AIGU"e][Suite]",

  "[1][--- Mod"e_GRAVE"le "a_GRAVE" n couches ---| "
     "| Aucune variable n'a "e_AIGU"t"e_AIGU
     "| d"e_AIGU"finie ! Ajustement"
     "| impossible.][Compris]",

  "[3][Variable mal initialis"e_AIGU"e"
     "|Couche : %.21s"
     "|%.8s initial : %.4g"
     "|min : %.5g - max : %.5g"
     "|Correction automatique.][ Suite ]",

  "[3][--- Mod"e_GRAVE"le "a_GRAVE" n couches ---"
     "|  Seuls les graphes de type"
     "|exafs ou transform"e_AIGU"e de"
     "|Fourier peuvent servir de"
     "|r"e_AIGU"f"e_AIGU"rence d'ajustement.][ Annuler ]",

  "[2][--- Mod"e_GRAVE"le "a_GRAVE" n couches ---| "
     "|   Voulez-vous vraiment"
     "|arr"e_CIRC"ter l'ajustement ?][ Non | Oui ]",

  "[3][**** Fermeture impossible ****"
     "| Il est impossible de fermer"
     "|cette fen"e_CIRC"tre tant"
     "|qu'un ajustement est en cours.][ Bien ]",

  "[3][--- Mod"e_GRAVE"le "a_GRAVE" n couches ---"
     "|  L'intervalle d'ajustement"
     "|choisi est vide !][ Annuler ]",

  "[3][--- Mod"e_GRAVE"le "a_GRAVE" n couches ---"
     "|   L'intervalle d'ajustement"
     "|choisi n'est pas d"e_AIGU"fini pour"
     "|le graphe de r"e_AIGU"f"e_AIGU"rence][ Annuler ]",

  "[2][---- Lancer un ajustement ----"
     "|  Que faire des r"e_AIGU"sultats de"
     "|l'ajustement pr"e_AIGU"c"e_AIGU"dent ?][Conserver| Perdre | Annuler ]",

  "[3][-- Barres d'erreur absentes --"
     "|  Pas d'"e_AIGU"cart-type moyen, ni"
     "|d'"e_AIGU"cart-type point par point."
     "|L'utilisation des erreurs est"
     "|impossible !][ Suite ]",

  "[3][Variable mal initialis"e_AIGU"e"
     "|Couche : %.21s"
     "|  La valeur minimale de DE0"
     "|pourrait conduire  des k"
     "|n"e_AIGU"gatifs. Correction r"e_AIGU"alis"e_AIGU"e][ Suite ]",

  "[3][---- Ajustement termin"e_AIGU" ----"
     "|  Une variable ne varie plus"
     "|de faon significative."
     "|Couche : %.21s"
     "|Variable : %.19s][ Bien ]",

  "[3][---- Ajustement termin"e_AIGU" ----"
     "|  Une variable a atteint les"
     "|limites de variation permises."
     "|Couche : %.21s"
     "|Variable : %.19s][ Bien ]",

  "[3][---- Ajustement termin"e_AIGU" ----"
     "|  L'erreur finale ne varie plus"
     "|de faon significative."
     "|Erreur finale : %.10g][ Bien ]",

  "[3][---- Ajustement termin"e_AIGU" ----"
     "|  L'erreur obtenue est plus"
     "|faible que celle demand"e_AIGU"e."
     "|Erreur finale : %.10g][ Bien ]",

  "[3][---- Ajustement termin"e_AIGU" ----"
     "|  L'algorithme a converg"e_AIGU", il"
     "|n'est pas possible de r"e_AIGU"duire"
     "|davantage l'erreur."
     "|Erreur finale : %.10g][ Bien ]",

  "[3][ !! Ajustement impossible !!"
     "| Un graphe indispensable pour"
     "| l'ajustement a "e_AIGU"t"e_AIGU" effac"e_AIGU"."
     "| Ajustement arr"e_CIRC"t"e_AIGU".][ Bien ]",

  "[3][--- Ajustement impossible ---"
     "|    L'absorbeur choisi ne"
     "|contient pas de graphe mod"e_GRAVE"le.][Annuler]",

  "[3][ V"e_AIGU"rification de l'ajustement"
     "|  Une variable a atteint les"
     "|limites de variation permises."
     "|Couche : %.21s"
     "|Variable : %.19s][Suite | Enlever | Fin ]",

  /*   v----------------------------v */
  "[3][--- Ajustement impossible ---"
     "|Une erreur s'est produite lors"
     "|du calcul du spectre modle.][ Fin ]"
};
#endif

extern char vrai_message[]; /* Dans variables.c */

int NC_ERREUR(unsigned int code_erreur, ...)
{
  int retour;
  char *ch_1, *ch_2;
  double d_1, d_2, d_3;
  va_list params;

  if (code_erreur > NOMBRE_MESSAGES)
  {
    return SYS_ERREUR(ERREUR_INCONNUE, code_erreur, "Ajustement "a_GRAVE" n couches");
  }

  va_start(params, code_erreur);

  switch (code_erreur)
  {
  case PAS_DE_PHASE:
  case PAS_D_AMPLITUDE: /* Un paramtre, de type char * */
    ch_1 = va_arg(params, char *); /* Nom de la couche avec l'erreur */
    sprintf(vrai_message, messages[code_erreur], ch_1);
    retour = form_alert(1, vrai_message);
    break;

  case INIT_INCORRECTE: /* Cinq paramtres : deux chanes puis trois doubles */
    ch_1 = va_arg(params, char *); /* Nom de la couche avec l'erreur */
    ch_2 = va_arg(params, char *); /* Variable errone */
    d_1 = va_arg(params, double);  /* Valeur initiale  */
    d_2 = va_arg(params, double);  /* Borne infrieure */
    d_3 = va_arg(params, double);  /* Borne suprieure */
    sprintf(vrai_message, messages[code_erreur],
	    ch_1, ch_2, d_1, d_2, d_3);
    retour = form_alert(1, vrai_message);
    break;

  case DEMIN_INCORRECT: /* Un paramtre : une chane */
    ch_1 = va_arg(params, char *);
    sprintf(vrai_message, messages[code_erreur], ch_1);
    retour = form_alert(1, vrai_message);
    break;

  case DELTAX_TROP_FAIBLE: /* Deux paramtres : chanes */
  case BORNE_ATTEINTE:
  case VERIF_BORNE_ATTEINTE:
    ch_1 = va_arg(params, char *);
    ch_2 = va_arg(params, char *);
    sprintf(vrai_message, messages[code_erreur], ch_1, ch_2);
    retour = form_alert(1, vrai_message);
    break;

  case DELTAERR_TROP_FAIBLE: /* Un paramtre : double */
  case ERR_MIN_ATTEINTE:
  case IMPOSSIBLE_MINIMISER:
    d_1 = va_arg(params, double); /* Valeur de l'erreur */
    sprintf(vrai_message, messages[code_erreur], d_1);
    retour = form_alert(1, vrai_message);
    break;

  default: /* Aucun paramtre */
    retour = form_alert(1, messages[code_erreur]);
  }

  va_end(params);
  return retour;
}
