/* Fonctions utilitaires gnrales
   Dveloppes pour LASE, mais plus gnriques
   (C) 1996 - 2002, Emmanuel CURIS

   Lecture "avance" des fichiers en ASCII : dclarations
*/

#ifndef ASCII_UTILS_H_

#define ASCII_UTILS_H_ /* Protection contre l'inclusion multiple */

#ifndef FAUX
# define FAUX 0
# define VRAI 1
#endif

unsigned int  compte_colonnes(FILE *fichier, int separateur);
unsigned long compte_lignes(FILE *fichier, int commentaire);
int           ignore_car   (FILE *fichier, unsigned int n_cars);
int           ignore_ligne (FILE *fichier);
int           sauter_en_tete(FILE *fichier, unsigned int nbr_lignes, int commentaire);
int           sauter_lignes(FILE *fichier, unsigned int nbr_lignes);

char *lit_mot     (FILE *fichier); /* Bloc fini par 2+ espaces */
char *lit_ligne   (FILE *fichier, unsigned long lg_ligne);
char *lit_commande(FILE *fichier); /* Bloc fini par 1+ espace */
char *lit_cars    (FILE *fichier, char *chaine, unsigned int n_cars);

int   lit_valeurs (FILE *fichier, unsigned int nbr_colonnes, int separateur, double *valeurs, double *erreurs);

#define EA_EXPORT_COLONNES_VIDES 1 /* Bit mis : on sauvegarde aussi les colonnes vides [avec des 0] */

struct EA_infos_export {
  unsigned int proprietes;	/* Masque de bits pour indiquer ce que l'on fait : cf ci-dessus */
  int separateur;		/* Sparateur de colonnes ; 0 = espace */
  unsigned int precision;	/* Combien de chiffres significatifs ? */
};

int EA_MultiColonnes(FILE *fichier, unsigned long nbr_points, unsigned int nbr_colonnes, double **tables, double **erreurs,
		     struct EA_infos_export *options);

#endif /* ASCII_UTILS_H_ */
